#include <bits/stdc++.h>
#define ll long long
using namespace std;
ll n,m,k;
vector<vector<ll>>G;
vector<bool>used;
vector<ll>T;
vector<pair<ll,ll>>H;
queue<ll>V;
void bfs(ll i){
    if(V.empty()){
        if(i>=0){
            V.push(H[i].second);
            T[H[i].second]=H[i].first;
            used[H[i].second]=true;
            bfs(i-1);
        }
        return;
    }
    ll v=V.front();
    if(i>=0 and T[v]==H[i].first and !used[H[i].second]){
        V.push(H[i].second);
        used[H[i].second]=true;
        T[H[i].second]=H[i].first;
        bfs(i-1);
        return;
    }
    V.pop();
    if(T[v]==0){
        bfs(i);
        return;
    }
    for(ll to:G[v]){
        if(!used[to]){
            used[to]=true;
            V.push(to);
            T[to]=T[v]-1;
        }
    }
    bfs(i);
}
int main() {
    //freopen("in.txt","r",stdin);
    cin>>n>>m>>k;
    G.resize(n);
    ll a,b;
    for(ll i=0;i<m;++i){
        cin>>a>>b;
        --a,--b;
        G[a].push_back(b);
        G[b].push_back(a);
    }
    H.resize(k);
    for(ll i=0;i<k;++i){
        cin>>H[i].second>>H[i].first;
        H[i].second--;
    }
    sort(H.begin(),H.end());
    used.resize(n,false);
    T.resize(n);
    bfs(k-1);
    vector<ll>Ans;
    for(ll i=0;i<n;++i){
        if(used[i]){
            Ans.push_back(i);
        }
    }
    if(Ans.size()==0){
        return 0;
    }
    cout<<Ans.size()<<"\n";
    for(ll elem:Ans){
        cout<<elem+1<<" ";
    }
    return 0;
}
