#include <bits/stdc++.h>

#define ll long long
using namespace std;
ll n, m, k;
vector<vector<ll>>G;
vector<bool>used;
queue<ll>q;
vector<pair<ll,ll>>H;
vector<ll>T;

void give(ll v,ll t){
    if(!used[v]){
        q.push(v);
        used[v]=true;
        T[v]=t;
    }
}

void bfs(ll i){
    if(q.empty()){
        if(i<0){
            return;
        }
        else{
            give(H[i].second,H[i].first);
            bfs(i-1);
            return;
        }
    }
    ll v=q.front();
    if(T[v]==H[i].first){
        give(H[i].second,H[i].first);
        bfs(i-1);
        return;
    }
    q.pop();
    if(T[v]==0){
        bfs(i-1);
        return;
    }
    for(ll to:G[v]){
        give(to,T[v]-1);
    }
    bfs(i);
}
int main() {
    //freopen("in.txt", "r", stdin);
    cin >> n >> m >> k;
    G.resize(n);
    used.resize(n,false);
    H.resize(k);
    T.resize(n);
    ll a,b;
    for(ll i=0;i<m;++i){
        cin>>a>>b;
        --a,--b;
        G[a].push_back(b);
        G[b].push_back(a);
    }
    for(ll i=0;i<k;++i){
        cin>>H[i].second>>H[i].first;
        H[i].second--;
    }
    sort(H.begin(),H.end());
    bfs(k-1);
    vector<ll>Ans(0);
    for(ll i=0;i<n;++i){
        if(used[i]){
            Ans.push_back(i+1);
        }
    }
    cout<<Ans.size()<<endl;
    for(ll elem:Ans){
        cout<<elem<<" ";
    }
}
